function [v] = barylagrangeinterp(x,y,u)
%%  Barycentric Langrange Interpolation 
%   This function does the barycentric lagrange interpolation with
%   p(x) = l(x)*Sum(0-n)[(wj/x-xj)*fj]

%   Adapted from the general lagrange interpolation code found in 
%   https://www.mathworks.com/moler/interp.pdf, accessed on May 25, 2014

%   Maximilian Jentzsch
%   Math 56 Final Project, Spring 2014


n = length(x);
t = zeros(size(u));
l = 1;
for j = 1:n
    wj = ones(size(u));
    for k = [1:j-1 j+1:n]
%       make the barycentric weights wj
        wj = 1./(x(j)-x(k)).*wj;
    end
    
    if (u-x(j)) ==0
        error('whoops! you are about to divide by zero.')
    end
    
    co = wj./(u-x(j));
    l = l.*(u-x(j));
    t=t+co*y(j);
    
end

    v=l.*t; 
end

